<!-- INSTALL-DEB.md - Removable HEADER Start -->

Last edited: Oct 13, 2018

<!-- Removable HEADER End -->

## <a name="instl_deb_top"></a>DEB Package Install for Ubuntu and Raspbian

> May be valid for other DEB Operating Systems

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

> If you're using a gateway, review the appropriate section in [Gateways](#gateways_top).

[Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_deb_comp)  
  [INSTALL or UPGRADE:](#instl_deb_iu)  
  [CONFIGURE:](#instl_deb_conf)  
  [FIRST STARTUP:](#instl_deb_fs)  
  [START/STOP/RESTART/RELOAD/STATUS:](#instl_deb_ss)  
  [AUTOSTART:](#instl_deb_as)  
  [LIST PACKAGE FILES:](#instl_deb_ls)  
  [PACKAGE REMOVAL:](#instl_deb_rm)  
  [KNOWN ISSUE - MODEMMANAGER MAY HANG NCID AT THE BOOT TIME:](#instl_deb_mm)

### <a name="instl_deb_comp"></a>COMPILE:

> It's very important to update the latest package info before
> continuing. Don't skip these two steps!  
> NOTE: The apt command is preferred over apt-get and apt-cache.
>
>          sudo apt update  
>          sudo apt upgrade

> If any packages were listed as "kept back" and "not upgraded", do:
>
>          sudo apt dist-upgrade

> The following packages are required:  
>
>          sudo apt install build-essential  
>          sudo apt install libpcap0.8-dev libpcre3-dev

> This package is required to run obi2ncid, rn2ncid, wc2ncid and wct:  
>
>          sudo apt install libconfig-simple-perl

> This package is required to run sip2ncid:  
>
>          sudo apt install libpcap0.8

> This additional package is required to run wc2ncid (install via cpan, see below):  
>
>          Data::HexDump


> See [INSTALL (generic)](#instl_generic_top) for compile instructions.

### <a name="instl_deb_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and client DEB packages to function.  The
  server is required on one computer or device, but the client can be
  installed on as many computers as needed.

> The client has most of the output modules in its DEB package, but there
  are optional output modules in their own DEB packages.

> If available, the latest NCID can be installed from a Ubuntu or a Raspbian
  repository using apt.

> If you cannot find a repository that contains NCID or if the latest packages
  are not available, you can download them from SourceForge and install them
  using gdebi or dpkg.

> It's very important to update the latest package info before
> continuing. Don't skip these two steps!
>
>                    sudo apt update
>                    sudo apt upgrade

> - **Install NCID from a Debian repository**

>> - Install required packages

>>          sudo apt install libpcap0.8-dev libpcre3-dev

>> - List the available packages:

>>          sudo apt search ncid

>> - Install the server (required):

>>          sudo apt install ncid_<version>-1_armhf.deb

>> - Install the client (optional):

>>          sudo apt install ncid-client_<version>-1_all.deb

>> - Install the gateways package (optional):

>>          sudo apt install ncid-gateways_<version>-1_armhf.deb

>> - Install any optional output modules wanted:

>>          sudo apt install ncid-<module>_<version>-1_all.deb

> - **Install NCID from DEB packages at SourceForge**

>> If the latest packages are not available at the Ubuntu or Raspbian repository:

>> - Download NCID Deb packages to install from SourceForge.  Assume the latest version is 1.10:

>>> -  Download ncid (required)

>>>        wget https://sourceforge.net/projects/ncid/files/ncid/1.10/ncid_1.10-1_armhf.deb

>>> -  If using the client, download ncid-client (optional)

>>>        wget https://sourceforge.net/projects/ncid/files/ncid/1.10/ncid-client_1.10-1_all.deb

>>> -  If using a gateway instead of a modem, download ncid-gateways (optional)

>>>        wget https://sourceforge.net/projects/ncid/files/ncid/1.10/ncid-gateways_1.10-1_armhf.deb

>>> - Download any optional output modules
    (most modules are included with the client package)

>>>        wget https://sourceforge.net/projects/ncid/files/ncid/1.10/ncid-<module>_1.10-1_all.deb

>> - You can use apt, gdebi or dpkg to install the local NCID packages and dependent packages.

>>> - Method 1: Install or Upgrade the packages using apt

>>>> - Install the NCID server and optional client:

>>>>          sudo apt install ./ncid_<version>-1_armhf.deb ./ncid-client_<version>-1_all.deb

>>>> - Install any optional gateways:

>>>>          sudo apt install ./ncid-gateways_<version>-1_armhf.deb

>>>> - Install any optional modules:

>>>>          sudo apt install ncid-<module>_<version>-1_all.deb

>>> - Method 2: Install or Upgrade the packages using gdebi-gtk (GUI):
>>>
>>>> - If needed use the menu item "Add/Remove.." to install the GDebi
    Package Installer.

>>>> -         Using the file viewer:  
>>>>
>>>>        - Open the file viewer to view the NCID DEB packages  
>>>>        - Select the DEB packages  
>>>>        - Double-click selections or right-click selections and select
 "Open with GDebi Package installer"  

>>> - Method 3: Install or Upgrade the packages using gdebi (command line):
>>>
>>>> - Install gdebi if needed:

>>>>          sudo apt install gdebi

>>>> - Install the NCID server:

>>>>          sudo gdebi ncid-<version>-1_armhf.deb

>>>> - Install the client package and default modules:

>>>>          sudo gdebi ncid-client-<version>-1_all.deb

>>>> - Install any optional gateways:

>>>>          sudo gdebi ncid-gateways_<version>-1_armhf.deb

>>>> - Install any optional modules:

>>>>          sudo gdebi ncid-<module>-<version>-1_all.deb

>>> - Method 4: Install or Upgrade the packages using dpkg (command line):

>>>> - Install the NCID server:

>>>>          sudo dpkg -i ncid-<version>_armhf.deb

>>>> - Install the client package and default modules:

>>>>          sudo dpkg -i ncid-client-<version>-1_all.deb

>>>> - Install any optional gateways:

>>>>          sudo dpkg -i ncid-gateways_<version>-1_armhf.deb

>>>> - Install any optional modules:

>>>>          sudo dpkg -i ncid-<module>-<version>-1_all.deb

>>>> - Force install of all dependencies:

>>>>          sudo apt-get install -f

> #### Notes:  
   &lt;version&gt; would be something like: 1.0  
   &lt;module&gt; would be a module name like: kpopup, mythtv, samba

### <a name="instl_deb_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/ttyACM0.  If you need to change it,
    set your modem port in ncidd.conf.  This assumes serial port 0:  
>
>          set ttyport = /dev/ttyS0

> - If you are using a Gateway to get the Caller ID instead of a
    local modem, you need to set cidinput:  
>
>          set cidinput = 2 # Caller ID from a gateway with modem support  
>          set cidinput = 3 # Caller ID from gateways without modem support  

> - If you are using a local modem with or without a Gateway:  
>
>          set cidinput = 0  (this is the default)  

### <a name="instl_deb_fs"></a>FIRST STARTUP:

> - If you are running the server and client on the same computer and 
    using a modem:  
>
>          sudo systemctl start ncidd  
>
>          ncid &

> - If you are running the server and using a gateway:  
>
>          sudo systemctl start ncidd <name of gateway>
>
>          ncid &

> - If you are running the server and using a Whozz Calling gateway, you 
 need to install the `Data::HexDump` Perl module using cpan:  
>
>          cpan  
>               interactive mode, first use will enter configure
>               configure as much as possible automatically
>               choose sudo from: (Choose 'local::lib', 'sudo' 
>                  or 'manual')
>               automatically choose some CPAN mirror
>               when configure finishes, it displays the cpan 
>               prompt: cpan[1]>
>
>          cpan[1]> install Data::HexDump 
>
>          cpan[2]> quit
>
>          sudo systemctl start ncidd wc2ncid 
>
>          ncid &

> - Call yourself and see if it works, if not:

>> stop the server and gateway:  
>
>>          sudo systemctl stop mcid wc2ncid

>> and continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways and
    client modules you are using to autostart at boot. There 
    are rc.init scripts for starting ncid with output modules, 
    for example: ncid-page, ncid-kpopup, etc.

> #### NOTE:
>> The ncid GUI client must be started after login, not boot.
   There is no ncid.init script to start or stop it.

### <a name="instl_deb_ss"></a>START/STOP/RESTART/RELOAD/STATUS:
START/STOP/STATUS:

> Use the systemctl command to control any of the daemons.  The systemstl
  commands are: start, stop, restart, reload and status.  The client using
  an output module can also be started using the <b>ncid-&lt;module&gt;</b>
  instead of <b>ncid</b>. All output modules can be run at the same time.

> Here are some examples:

> - Start the NCID server:  
>
>>          sudo systemctl start ncidd

> - Stop the sip2ncid server:  
>
>>          sudo systemctl stop sip2ncid

> - Restart the sip2ncid server:  
>
>>          sudo systemctl restart sip2ncid

> - Reload the server alias file:  
>
>>          sudo systemctl reload ncidd

> - Start ncid with ncid-page:  
>
>>          sudo systemctl start ncid-page

> - Status of ncid with ncid-speak:  
>
>>          sudo systemctl status ncid-speak

> Review the man page: **man systemctl**

### <a name="instl_deb_as"></a>AUTOSTART:

> Use the systemctl command to enable/disable the service at boot.

> Here are some examples:

> - Start ncidd at boot:  
>
>>          sudo systemctl enable ncidd

> - Start ncid-page at boot:  
>
>>          sudo systemctl enable ncid-page

> - Disable ncidd startup at boot:  
>
>>          sudo systemctl disable ncidd

> Review the man page: **man systemctl**

> See also [this section about a known issue where ModemManager may hang NCID at the boot time](#instl_deb_mm).

### <a name="instl_deb_ls"></a>LIST PACKAGE FILES:

> - To see all the files the package installed onto your system:

>>           dpkg-query -L <package_name>

> - To see the files a .deb file will install

>>          dpkg-deb -c <package_name.deb>

> - To work directly with package names rather than package files, you can use apt-file.  
    It lists contents for packages in your already-configured Apt repositories.  
    It is irrelevant whether any particular package is or is not installed.

>> You may need to install the apt-file package first:

>>          sudo apt-file update
>>          apt-file list package_name

>> After installing apt-file:

>>          apt-file list <package_name>



### <a name="instl_deb_rm"></a>PACKAGE REMOVAL:

> Use apt to remove any NCID package installed.

> For example, to use apt to remove the ncid package:

> - Normal removal without removing configuration files and dependencies:  
>
>>          sudo apt remove ncid

> - Complete removal including configuration files:  
>
>>          sudo apt purge ncid

> - Remove ncid dependencies no longer needed:  
>
>>          sudo apt autoremove

> Review the man page: **man apt**

### <a name="instl_deb_mm"></a>KNOWN ISSUE - MODEMMANAGER MAY HANG NCID AT THE BOOT TIME:

> #### Configurations known to have the issue:

> - You are running Ubuntu 14.xx or later with the ModemManager installed and running.
> - You are running Debian 9.xx or later and the ModemManager is not installed and/or is not running.
> - You are running Ubuntu Mate on an Raspberry Pi model 3.
> - You are running Raspbian Jessie on an Raspberry Pi model 3.
> - It is a hardware modem mounted internally on a PCI card.
> - It is a USB modem.

> #### Symptoms:

> - The NCID server is not sending caller ID to clients on your network.
> - Clients are unable to connect to the NCID server.
> - The NCID server log /var/log/ncidd.log indicates modem
>   initialization did not complete and appears to be hung.
>   This also prevents other processes after it from starting until the NCID server is killed.
> - You may see very strange modem responses in the NCID server log.
> - The NCID server problem is fixed by manually restarting it after the Operating System boots.
> - The NCID server problem is fixed by manually unplugging and re-plugging in the USB modem.

> #### Solution: If the ModemManager is installed

>> The ModemManager is searching for a mobile broadband (2G/3G/4G) capable devices,
>> by querying various Serial and USB connected devices at the boot time,
>> by sending "AT+GCAP" (the AT command for a modem to "Request Complete Capabilities List").
>> This can collide in terms of the devices initialization timing, with the NCID server and the XDMF to NCID gateway.

>> The solution is to create the udev rules that will exclude from probing,
>> devices used by the NCID server and XDMF to NCID gateway.  
>> Check out /usr/share/doc/ncid/README.udev for details.

>> Disabling the ModemManager should be used as a last resort,
>> if for some reason the method of the udev rules fails.  
>> Issue the following commands:
>
>>          sudo systemctl disable ModemManager.service  
>>          sudo systemctl stop ModemManager.service  
>>          sudo systemctl status ModemManager.service  

>> The **disable** line will prevent ModemManager from starting at the boot.

>> The **stop** line will terminate the currently running instance of
>> ModemManager.

>> The **status** lines should look like this:  
>
>>          ● ModemManager.service - Modem Manager  
>>             Loaded: loaded (/usr/lib/systemd/system/ModemManager.service; disabled; vendor preset: enabled)  
>>             Active: inactive (dead)  

>> In the cases where the Operating System has no systemctl available, 
>> disable ModemManager completely by removing its execute permissions, 
>> with the following command:  
>
>>          sudo chmod ugo-x /usr/sbin/ModemManager
